#define HEIGHT       44          
#define WIDTH        80          
#define LIVELY       '*'         
#define DEADLY       ' '         
#define TRUE         1
#define FALSE        0
#define BLUE 31	
#define MAX(a,b) ( ( (a) > (b) ) ? (a) : (b) )
#define MIN(a,b) ( ( (a) < (b) ) ? (a) : (b) )

typedef enum { alive, dead } state;

typedef struct { 
       state  lookslikeitis;
       int    nearby;
}  cell;

typedef char screenline[WIDTH];

 struct edges {
     int left;
     int right;
     int top;
     int bottom;
   };
      
struct edges  edge;

int population, births, deaths, mouse;
 
cell board[HEIGHT+2][WIDTH+2];
char  quit, ch, comment[40];
long int pause;
short int egafnd = 0;
int height;

#include <dos.h>
#include <stdio.h>

main()
  { 
    void setmode();
    void update();
    void title();
    void getpositions();
    void initialize();
    void countneighbors();
    void ega43();
    char yes();
    int first = 1, generation;
    union REGS wregs;
    int memsize, mode, menusave;
    unsigned int features, switches;
    char *commptr;
    do { 
      if (!(egafnd = ega_info(&memsize, &mode, &features, &switches)))
          height = 26;
      else
          height = 44;
      setmode();
      initialize(); 
      ega43();
      cls(0x11, 43, 80);       
      title();
      if ((menusave = menu1()) == 2)
         getpositions(1); 
      else {
        commptr = comment;
        while (*commptr == ' ')
          commptr++;
        if (strlen(commptr)) {
           gotoxy(0, 5 + ( 65 - strlen(commptr) ) / 2);
           printf("%s", commptr);
        }
        if (menusave == 3)
          getpositions(0);
      }
      generation = 0;
      pause = 10; 
      quit = FALSE; 
      while (!quit) { 
        gotoxy(0, 70);
        printf("Gen. \%4d", ++generation);
        countneighbors(); 
        update(); 
        delay(pause); 
        quit = (population == 0) || ((births == 0) && (deaths == 0)); 
        if (mouse) {
          wregs.x.ax = 3;                /* return position & button status */
          int86(51, &wregs, &wregs);     /* terminate when right button is pushed */
          if (wregs.x.bx == 2) quit = TRUE;
          if (wregs.x.bx == 1) pause = MAX(pause - 16, 0);
        }
        if (kbhit()) { 
            ch = getche(); 
            if ((ch == '>') || (ch == '.')) pause = MIN(pause + 16, 255); 
            else if ((ch == '<') || (ch == ',')) pause = MAX(pause - 16, 0); 
            else quit = TRUE; 
        } 
      } 
      gotoxy(22, 1); 
    
      if (population == 0) {
        gotoxy(height-3, 5);
        printf("This colony has died out.\n"); 
      }
      else
       printf("\n"); 
     gotoxy(height-2, 5);
  }  while (!(!yes("Would you like to run LIFE again?"))); 
  setmode();
}


void
  killtypeahead() 
{ 
  if (kbhit()) getche(); 
} /* killtypeahead */ 

char  yes(s) 
   screenline s; 
  {
    char ch;

   printf("%s Y/N ",s); 
   killtypeahead(); 
   do { 
      ch = getche();
   }  while (!((ch == 'y') || (ch == 'Y') || (ch == 'n') || (ch == 'N'))); 
   return ((toupper(ch) == 'Y') ? 1 : 0); 
} /* yes */ 

void resetedges() 
{ 
  edge.top = height - 1; 
  edge.right = 1; 
  edge.left = WIDTH - 1; 
  edge.bottom = 1; 
} /* resetedges */ 

void lecture_on_life() 
  { 
    cls(0x11, 25, 80); 
    printf("LIFE simulates the growth of a colony of animalcules in a \""); 
    printf("%1d by %1d World\".\n",WIDTH, height-1); 
    printf("\nWhether a cell is born, lives or dies depends on the number of living\n"); 
    printf("animalcules near by.  If a cell is empty and has exactly 3 neighbors, it\n"); 
    printf("will be born in the next generation.  If it is alive and has 2 or 3\n"); 
    printf("neighbors, it will stay alive.  Otherwise, it either dies of loneliness\n"); 
    printf("or suffocates from overcrowding.\n"); 
    gotoxy(22, 0); 
    printf("(* any key continues *) "); 
    killtypeahead(); 
    getche();
    cls(0x11, 25, 80); 
    printf("Here are some examples\n\n");
    printf("                                            *\n");
    printf("                       ***   becomes        *         the next generation\n");
    printf("                                            *\n\n\n");
    printf("                                            *\n");
    printf("                       ***                 * *\n");
    printf("                       ***   becomes      *   *      the next generation\n");
    printf("                       ***                 * *\n");
    printf("                                            *\n\n\n");
    printf("                       **    becomes                 the next generation\n");
    gotoxy(22, 0); 
    printf("(* any key continues *) "); 
    killtypeahead(); 
    getche();
    cls(0x11, 25, 80);
    printf("                 Entering cells into the pattern\n\n"); 
    printf("The Microsoft mouse is used to locate the desired cell. Pressing and\n");
    printf("releasing the left button will place a cell in a vacant position, or\n");
    printf("erase a cell from an occupied one.  When the pattern is complete,\n"); 
    printf("press and release the right button to start the program.\n\n");
    gotoxy(22, 0); 
    printf("(* any key continues *) "); 
    killtypeahead(); 
    getche();
  } /* lecture_on_life */ 

void title() 
  { 
     cls(0x11, 25, 80);  
     gotoxy(1, 28);
     printf("THE GAME OF LIFE\n\n"); 
   } /* title */ 

void initialize() 
{
   int  down, across;

  for (down = 0; down <= height; down++) 
      for (across = 0; across <= WIDTH; across++) { 
         board[down][across].lookslikeitis = dead; 
         board[down][across].nearby = 0; 
      } 
  resetedges(); 
} /* initialize */ 

void limits(x, y) 
   int  x, y; 
  { 
    edge.left   = MIN(edge.left, x); 
    edge.right  = MAX(edge.right, x); 
    edge.top    = MIN(edge.top, y); 
    edge.bottom = MAX(edge.bottom, y); 
  } /* limits */ 

void  clearnearby() 
{
   int down, across;

  for (down = edge.top - 1; down <= edge.bottom + 1; down++) 
      for (across = edge.left - 1; across <= edge.right + 1; across++) 
          board[down][across].nearby = 0; 
} /* clearnearby */ 

void countneighbors() 
{ 
  int  down, across, deltadown, deltacross;

clearnearby(); 
 for (down = edge.top - 1; down <= edge.bottom + 1; down++) 
  for (across = edge.left - 1; across <= edge.right; across++) 
      if (board[down][across].lookslikeitis == alive) 
         for (deltadown = -1; deltadown <= 1; deltadown++) 
            for (deltacross = -1; deltacross <= 1; deltacross++) 
              if ((down+deltadown) <= (height+1) && (across+deltacross) <= (WIDTH+1))  
                  board[down+deltadown][across+deltacross].nearby++;
} /* countneighbors */ 

void update() 
{
  int down, across;
  struct edges localedge;

  births = deaths = 0; 

  localedge.left   = edge.left;
  localedge.right  = edge.right;
  localedge.top    = edge.top;
  localedge.bottom = edge.bottom;
  resetedges(); 

  for (down = MAX(0, localedge.top - 1);
        down <= MIN(height, localedge.bottom + 1);
/*      down <= MIN(height - 1, localedge.bottom + 1);*/
         down++) 
  for (across = MAX(0, localedge.left - 1);
        across <= MIN(WIDTH, localedge.right + 1);
/*      across <= MIN(WIDTH - 1, localedge.right + 1);*/
          across++) 
        switch (board[down][across].lookslikeitis) {
          
          case dead:   
            if (board[down][across].nearby == 3) 
              { 
                board[down][across].lookslikeitis = alive; 
                if ((down > 2) && (across > 0)) {
                  gotoxy(down - 2, across - 1); 
                  putc(LIVELY, stdout);
                }
                limits(across, down); 
                ++births; 
              } 
          break; 
          
          case alive:   
            if ((board[down][across].nearby == 3) ||
                 (board[down][across].nearby == 4)) limits(across, down); 
            else 
              { 
                board[down][across].lookslikeitis = dead; 
                if ((down > 2) && (across > 0)) {
                  gotoxy(down - 2, across - 1); 
                  putc(DEADLY, stdout);
                }
                ++deaths; 
              } 
          break; 
          } /* case */ 
  population += births - deaths; 
  gotoxy(1, 1); 
} /* update */ 

void  reprinttopline() 
  {
    int  across;
  
    gotoxy(1, 1); 
    for (across = 0; across <= WIDTH - 1; across++)     
      if (board[0][across].lookslikeitis == dead)
           putc(DEADLY, stdout);
       else
          putc(LIVELY, stdout);
  } /* reprinttopline */ 

void  getpositions(clear)
  int clear; 
{
   int   down, across, row;
   char  finished, loop;
   union REGS wregs;
   struct SREGS segments, *segregs;
   int asave, dsave;

   finished = FALSE; 
   population = 0;
   if (clear) cls(0x11, 43, 80);
   wregs.x.ax = 0;                    /* Microsoft mouse driver?          */
   int86(51, &wregs, &wregs);
   mouse = wregs.x.ax;                /* save result                      */

   if (mouse) {                       /* Microsoft mouse driver in system? */
     wregs.x.ax = 10;                 /* define mouse cursor */
     wregs.x.bx = 0;
     wregs.x.cx = 0x77ff;
     wregs.x.dx = 0x7700;
     int86(51, &wregs, &wregs);

     wregs.x.ax = 1;                  /* show mouse cursor   */
     int86(51, &wregs, &wregs);

     wregs.x.ax = 8;                  /* set vertical cursor movement */
     wregs.x.cx = 8;                  /* minimum                      */
     wregs.x.dx = 341;                /* maximum - set for 43 (-1)    */
     int86(51, &wregs, &wregs);       /*           line ega           */

     wregs.x.ax = 4;                  /* initialize cursor position    */
     wregs.x.cx = 4;                  /* horizontal position           */
     wregs.x.dx = 4;                  /* vertical position             */
     int86(51, &wregs, &wregs);

     wregs.x.ax = 3;                /* return position & button status */
     int86(51, &wregs, &wregs);
     while ((wregs.x.bx & 0x0002) != 2) { /* terminate when right button is pushed */
       if (wregs.x.bx & 0x0001) {     /* left button down                */
           dsave = wregs.x.dx / 8;    /* save coordnates                 */
	   asave = wregs.x.cx / 8;  
	   loop = TRUE;
	   while (loop) { 
              wregs.x.ax = 6;            /* wait until coordinates change   */
              wregs.x.bx = 0;            /* or the left button is released  */
  	      int86(51, &wregs, &wregs); 
              if (!(wregs.x.ax & 0x0001) && !wregs.x.bx) { /* released */
                wregs.x.ax = 3;                /* get current position      */
                int86(51, &wregs, &wregs);
	        if ((dsave == wregs.x.dx/8) && (asave == wregs.x.cx/8)) {
                  wregs.x.ax = 2;                  /* hide mouse cursor   */
                  int86(51, &wregs, &wregs);
                  markpos(dsave + 2, asave + 1, &finished);
                  wregs.x.ax = 1;                  /* show mouse cursor   */
                  int86(51, &wregs, &wregs);
                }
                loop = FALSE;
              }     
              else {
                wregs.x.ax = 3;                /* get current position      */
                int86(51, &wregs, &wregs);
                if ((dsave != wregs.x.dx/8) || (asave != wregs.x.cx/8)) 
  	         loop = FALSE;
              }
           }
       }  
     wregs.x.ax = 3;                /* return position & button status */
     int86(51, &wregs, &wregs);
     }                              /* right button has been depressed */    
      wregs.x.ax = 0;               /* reset driver                    */
     int86(51, &wregs, &wregs);
     menu2(clear);                  /* clear == 0 => edit mode         */
     return;
} /* verify mouse */

} /* getposmarkitions */ 


dskpositions (input_file) 
FILE  *input_file;

{
   FILE *fopen();
   int   down, across, row;
   char  finished, loop, type[1];
   union REGS wregs;

   finished = FALSE; 
   cls(0x11, height - 1, 80);

   wregs.x.ax = 0;                    /* Microsoft mouse driver?          */
   int86(51, &wregs, &wregs);
   mouse = wregs.x.ax;                /* save result                      */
   if (mouse) {                       /* Microsoft mouse driver in system? */
     wregs.x.ax = 10;                 /* define mouse cursor */
     wregs.x.bx = 0;
     wregs.x.cx = 0x77ff;
     wregs.x.dx = 0x7700;
     int86(51, &wregs, &wregs);
   }
   fscanf(input_file, "%1c%40c", type, comment);
   while (!feof(input_file)) {
      fscanf(input_file, "%2d%2d", &down, &across);

/**********************************************************************
 *                                                                    *
 *          Try to allow for a game created for ega, but being        *
 *          on a non-ega system.                                      *
 *                                                                    *
 **********************************************************************/

      if (!egafnd && strncmp(type, 'E', 1) && down > 10)
          down -= 10;
      markpos(down + 2, across + 1, &finished);
   } 
   fclose(input_file);
   return;
} /* dskposmarkitions */ 

markpos(down, across, finished)
  int down, across;
  char *finished;
  {
       limits(across, down); 
       gotoxy(down - 2, across - 1);
       if (board[down][across].lookslikeitis == alive) { 
           putc(DEADLY, stdout);
           board[down][across].lookslikeitis = dead; 
           population--;
       } 
       else { 
           putc(LIVELY, stdout);
           board[down][across].lookslikeitis = alive; 
           population++;
       }
  }

cls(fattr, rows, cols)
  short int fattr, rows, cols;

/*  Clears the screen with the specified attribute */

  {
    union REGS wreg;

    gotoxy(0, 0);
    wreg.x.bx = fattr;
    wreg.x.cx = 80 * height;
    wreg.h.ah = 9;           /* video service 9 */
    wreg.h.al = ' ';
    int86(0x0010, &wreg, &wreg);   
    gotoxy(1, 0);
  }

/*
Ŀ
jzdelay.c                                                                   
Hold the program in a wait state for the specified number of clock tics.    
Note that this is NOT tied to processor speed.                              
                                                                            
Notes: there are approx 18.2 tics a second.                                 
                                                                            
 (C) JazSoft Software by Jack A. Zucker (301) 794-5950                      

*/


delay(ftics)
long ftics;
{
   long wstart; 		/* hold the starting time */
   long welapse;		/* count of elapsed tics  */
   union REGS sreg,dreg; 

   sreg.x.ax = 0;		/* return timer count function */
   int86(0x1A,&sreg,&dreg);
   wstart = (long) (dreg.x.cx << 16) | dreg.x.dx;
   welapse = 0;
   while (ftics > welapse) {
     sreg.x.ax = 0;		/* return timer count function */
     int86(0x1A,&sreg,&dreg);
     welapse = ((long) (dreg.x.cx << 16) | dreg.x.dx) - wstart;
   }
}


gotoxy (row, col )
unsigned char row, col;
{
  union REGS wreg;

  wreg.h.bh = 0;	     /* page 0 */
  wreg.h.ah = 2;             /* interrupt 10h function #2 */
  wreg.h.dh = row;
  wreg.h.dl = col;
  int86(0x10, &wreg, &wreg);
}

void ega43()
{
  union REGS wreg;
  struct SREGS segments, *segregs;
  
  if (!egafnd)
     return;

  wreg.x.ax = 0x0003;
  int86(0x10, &wreg, &wreg); /* set 80 column alpha mode */
  
  
  wreg.x.ax = 0x1112;          /* load 8x8 font             */
  wreg.h.bl = 0;               /* into block zero           */
  int86(0x10, &wreg, &wreg);   /* and recalc screen         */
  
  wreg.x.ax = 0x100;           /* set cursor                */
  wreg.h.bh = 0;               /*  for page 0               */
  wreg.x.cx = 0x600;           /*    to last two lines      */
  int86(0x10, &wreg, &wreg);   /*      start on 6, off on 0 */
  }
  


void setmode()
{
  union REGS wreg;
  
  wreg.x.ax = 0x0003;
  int86(0x10, &wreg, &wreg); /* set 80 column alpha mode */
  }
